unit Devap;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, NumEdit, ExtCtrls, Uproject, Uglobals, Buttons,
  GridEdit;

const
  MonthLabels1: PChar = 'Jan'#13'Feb'#13'Mar'#13'Apr'#13'May'#13'Jun';
  MonthLabels2: PChar = 'Jul'#13'Aug'#13'Sep'#13'Oct'#13'Nov'#13'Dec';

type
  TEvaporationForm = class(TForm)
    EvapTypeGroup: TRadioGroup;
    OKBtn: TButton;
    CancelBtn: TButton;
    HelpBtn: TButton;
    Notebook1: TNotebook;
    ConstEvapLabel: TLabel;
    ConstEvapEdit: TNumEdit;
    TimeSeriesLabel: TLabel;
    TimeSeriesCombo: TComboBox;
    GridEdit1: TGridEditFrame;
    GridEdit2: TGridEditFrame;
    procedure FormCreate(Sender: TObject);
    procedure EvapTypeGroupClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetData(E: TEvaporation);
    procedure GetData(E: TEvaporation);
  end;

//var
//  EvaporationForm: TEvaporationForm;

implementation

{$R *.dfm}

procedure TEvaporationForm.FormCreate(Sender: TObject);
begin
  Uglobals.SetFont(self);
  with GridEdit1.Grid do
  begin
    DefaultColWidth := 48;
    Rows[0].SetText(MonthLabels1);
  end;
  with GridEdit2.Grid do
  begin
    DefaultColWidth := 48;
    Rows[0].SetText(MonthLabels2);
  end;
end;

procedure TEvaporationForm.EvapTypeGroupClick(Sender: TObject);
var
  Flag0: Boolean;
begin
   if EvapTypeGroup.ItemIndex = 1 then
     Notebook1.PageIndex := 1
   else
   begin
     Notebook1.PageIndex := 0;
     Flag0 := (EvapTypeGroup.ItemIndex = 0);
     ConstEvapLabel.Enabled := Flag0;
     ConstEvapEdit.Enabled := Flag0;
     TimeSeriesLabel.Enabled := not Flag0;
     TimeSeriesCombo.Enabled := not Flag0;
   end;
end;

procedure TEvaporationForm.SetData(E: TEvaporation);
var
  I: Integer;
begin
  EvapTypeGroup.ItemIndex := E.EvapType;
  TimeSeriesCombo.Items := Project.Lists[TIMESERIES];
  TimeSeriesCombo.Text := E.Tseries;
  for I := 0 to 5 do
  begin
    GridEdit1.Grid.Cells[I,1] := E.EvapData[I];
    GridEdit2.Grid.Cells[I,1] := E.EvapData[I+6];
  end;
  ConstEvapEdit.Text := E.EvapData[0];
  EvapTypeGroupClick(self);
end;

procedure TEvaporationForm.OKBtnClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TEvaporationForm.GetData(E: TEvaporation);
var
  I: Integer;
  S: String;
begin
  E.EvapType := EvapTypeGroup.ItemIndex;
  case E.EvapType of
  CONSTANT_EVAP:
    for I := 0 to 11 do E.EvapData[I] := ConstEvapEdit.Text;
  MONTHLY_EVAP:
    for I := 0 to 5 do
    begin
      S := GridEdit1.Grid.Cells[I,1];
      if Length(Trim(S)) = 0 then S := '0.0';
      E.EvapData[I] := S;
      S := GridEdit2.Grid.Cells[I,1];
      if Length(Trim(S)) = 0 then S := '0.0';
      E.EvapData[I+6] := S;
    end;
  TSERIES_EVAP:
    E.Tseries := TimeSeriesCombo.Text;
  end;
end;

procedure TEvaporationForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTEXT, 211280);
end;

end.
